from numpy import *
from grmpy import models, inference, cpds

#B: Burglar, E: Earthquake, J: John calls, M: Marry Calls
N=5;  B,E,A,J,M = range(N)
dag = zeros((N,N))
dag[[B,E], A] = 1
dag[A, [J,M]] = 1
sizes = 2*ones(N,int) #All variables are binary
probs = [[],]*N
probs[B] = .001;  probs[E] = .002
probs[A] = [.95,.94],[.29,.001]
probs[A] = [.95,.94],[.29,.001]
probs[J] = [.90,.05];  probs[M] = [.70,.01]

from collections import Iterable
def expandBernoulli(cpd):
  if isinstance(cpd, Iterable): 
    return [expandBernoulli(x) for x in cpd]
  else: return [cpd, 1.-cpd]

node_cpds = expandBernoulli(probs)
node_cpds = [cpds.TabularCPD(array(x)) for x in node_cpds]

net = models.bnet(dag, sizes, node_cpds=node_cpds)
net.init_inference_engine(exact=True)

evidence = [None]*N;  evidence[J]=0
net.sum_product(evidence)
print 'P(A=t|J=t) = %.4f'%net.marginal_nodes([A]).T[0]
